# python build stubs for package datago
# File is generated by gopy. Do not edit.
# gopy pkg -author=Photoroom -email=team@photoroom.com -url= -name=datago -version=0.3 .

from pybindgen import retval, param, Function, Module
import sys

class CheckedFunction(Function):
    def __init__(self, *a, **kw):
        super(CheckedFunction, self).__init__(*a, **kw)
        self._failure_expression = kw.get('failure_expression', '')
        self._failure_cleanup = kw.get('failure_cleanup', '')

    def set_failure_expression(self, expr):
        self._failure_expression = expr

    def set_failure_cleanup(self, expr):
        self._failure_cleanup = expr

    def generate_call(self):
        super(CheckedFunction, self).generate_call()
        check = "PyErr_Occurred()"
        if self._failure_expression:
            check = "{} && {}".format(self._failure_expression, check)
        failure_cleanup = self._failure_cleanup or None
        self.before_call.write_error_check(check, failure_cleanup)

def add_checked_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

def add_checked_string_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_cleanup('if (retval != NULL) free(retval);')
    fn.after_call.add_cleanup_code('free(retval);')
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

mod = Module('_datago')
mod.add_include('"datago_go.h"')
mod.add_function('GoPyInit', None, [])
mod.add_function('DecRef', None, [param('int64_t', 'handle')])
mod.add_function('IncRef', None, [param('int64_t', 'handle')])
mod.add_function('NumHandles', retval('int'), [])
mod.add_function('Slice_bool_CTor', retval('int64_t'), [])
mod.add_function('Slice_bool_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_bool_elem', retval('bool'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_bool_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_bool_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('bool', 'value')])
mod.add_function('Slice_bool_append', None, [param('int64_t', 'handle'), param('bool', 'value')])
mod.add_function('Slice_byte_CTor', retval('int64_t'), [])
mod.add_function('Slice_byte_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_byte_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_byte_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_byte_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_from_bytes', retval('int64_t'), [param('PyObject*', 'o', transfer_ownership=False)])
mod.add_function('Slice_byte_to_bytes', retval('PyObject*', caller_owns_return=True), [param('int64_t', 'handle')])
mod.add_function('Slice_error_CTor', retval('int64_t'), [])
mod.add_function('Slice_error_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_error_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_error_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_error_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_error_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_float32_CTor', retval('int64_t'), [])
mod.add_function('Slice_float32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float32_elem', retval('float'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('float', 'value')])
mod.add_function('Slice_float32_append', None, [param('int64_t', 'handle'), param('float', 'value')])
mod.add_function('Slice_float64_CTor', retval('int64_t'), [])
mod.add_function('Slice_float64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float64_elem', retval('double'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('double', 'value')])
mod.add_function('Slice_float64_append', None, [param('int64_t', 'handle'), param('double', 'value')])
mod.add_function('Slice_int_CTor', retval('int64_t'), [])
mod.add_function('Slice_int_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int16_CTor', retval('int64_t'), [])
mod.add_function('Slice_int16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int16_elem', retval('int16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int16_t', 'value')])
mod.add_function('Slice_int16_append', None, [param('int64_t', 'handle'), param('int16_t', 'value')])
mod.add_function('Slice_int32_CTor', retval('int64_t'), [])
mod.add_function('Slice_int32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int32_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_int32_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_int64_CTor', retval('int64_t'), [])
mod.add_function('Slice_int64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int64_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int64_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int8_CTor', retval('int64_t'), [])
mod.add_function('Slice_int8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int8_elem', retval('int8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int8_t', 'value')])
mod.add_function('Slice_int8_append', None, [param('int64_t', 'handle'), param('int8_t', 'value')])
mod.add_function('Slice_rune_CTor', retval('int64_t'), [])
mod.add_function('Slice_rune_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_rune_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_rune_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_rune_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_rune_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_string_CTor', retval('int64_t'), [])
mod.add_function('Slice_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_string_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_string_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_string_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_string_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_uint_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint16_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint16_elem', retval('uint16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint16_t', 'value')])
mod.add_function('Slice_uint16_append', None, [param('int64_t', 'handle'), param('uint16_t', 'value')])
mod.add_function('Slice_uint32_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint32_elem', retval('uint32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint32_t', 'value')])
mod.add_function('Slice_uint32_append', None, [param('int64_t', 'handle'), param('uint32_t', 'value')])
mod.add_function('Slice_uint64_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint64_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint64_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint8_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint8_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_uint8_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_datago_SampleMetadata_CTor', retval('int64_t'), [])
mod.add_function('Slice_datago_SampleMetadata_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_datago_SampleMetadata_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_datago_SampleMetadata_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_datago_SampleMetadata_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_datago_SampleMetadata_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_datago_URLLatent_CTor', retval('int64_t'), [])
mod.add_function('Slice_datago_URLLatent_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_datago_URLLatent_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_datago_URLLatent_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_datago_URLLatent_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_datago_URLLatent_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Map_string_datago_ImagePayload_CTor', retval('int64_t'), [])
mod.add_function('Map_string_datago_ImagePayload_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_datago_ImagePayload_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_ImagePayload_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_ImagePayload_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('Map_string_datago_ImagePayload_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_ImagePayload_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Map_string_datago_LatentPayload_CTor', retval('int64_t'), [])
mod.add_function('Map_string_datago_LatentPayload_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_datago_LatentPayload_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_LatentPayload_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_LatentPayload_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('Map_string_datago_LatentPayload_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_datago_LatentPayload_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Map_string_interface__CTor', retval('int64_t'), [])
mod.add_function('Map_string_interface__len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_interface__elem', retval('char*'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_interface__contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_interface__set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('char*', 'value')])
mod.add_function('Map_string_interface__delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_interface__keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImageSize_CTor', retval('int64_t'), [])
mod.add_function('datago_ImageSize_Width_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImageSize_Width_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImageSize_Height_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImageSize_Height_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'datago_ImageSize_AspectRatio', retval('double'), [param('int64_t', '_handle')])
mod.add_function('datago_Sample_CTor', retval('int64_t'), [])
mod.add_function('datago_Sample_ID_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_ID_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_Sample_Source_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Source_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_Sample_Attributes_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Attributes_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_Image_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Image_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_Masks_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Masks_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_AdditionalImages_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_AdditionalImages_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_Latents_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Latents_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_CocaEmbedding_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_CocaEmbedding_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_Sample_Tags_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Sample_Tags_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_SampleMetadata_CTor', retval('int64_t'), [])
mod.add_function('datago_SampleMetadata_Id_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_SampleMetadata_Id_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_SampleMetadata_Attributes_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_SampleMetadata_Attributes_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_SampleMetadata_ImageDirectURL_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_SampleMetadata_ImageDirectURL_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_SampleMetadata_Latents_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_SampleMetadata_Latents_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_SampleMetadata_Tags_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_SampleMetadata_Tags_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_URLLatent_CTor', retval('int64_t'), [])
mod.add_function('datago_URLLatent_URL_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_URLLatent_URL_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_URLLatent_LatentType_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_URLLatent_LatentType_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_URLLatent_IsMask_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('datago_URLLatent_IsMask_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('datago_DataroomClient_CTor', retval('int64_t'), [])
add_checked_function(mod, 'datago_DataroomClient_Start', None, [param('int64_t', '_handle'), param('bool', 'goRun')])
add_checked_function(mod, 'datago_DataroomClient_GetSample', retval('int64_t'), [param('int64_t', '_handle')])
add_checked_function(mod, 'datago_DataroomClient_Stop', None, [param('int64_t', '_handle'), param('bool', 'goRun')])
mod.add_function('datago_ImagePayload_CTor', retval('int64_t'), [])
mod.add_function('datago_ImagePayload_Data_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_Data_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_OriginalHeight_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_OriginalHeight_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_OriginalWidth_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_OriginalWidth_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_Height_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_Height_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_Width_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_Width_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_Channels_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_Channels_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_ImagePayload_DataPtr_Get', retval('uint64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_ImagePayload_DataPtr_Set', None, [param('int64_t', 'handle'), param('uint64_t', 'val')])
mod.add_function('datago_PageRequest_CTor', retval('int64_t'), [])
mod.add_function('datago_Response_CTor', retval('int64_t'), [])
mod.add_function('datago_Response_Next_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('datago_Response_Next_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('datago_Response_SampleMetadata_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_Response_SampleMetadata_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_URLPayload_CTor', retval('int64_t'), [])
mod.add_function('datago_ARAwareTransform_CTor', retval('int64_t'), [])
mod.add_function('datago_LatentPayload_CTor', retval('int64_t'), [])
mod.add_function('datago_LatentPayload_Data_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_LatentPayload_Data_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_LatentPayload_Len_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_LatentPayload_Len_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('datago_LatentPayload_DataPtr_Get', retval('uint64_t'), [param('int64_t', 'handle')])
mod.add_function('datago_LatentPayload_DataPtr_Set', None, [param('int64_t', 'handle'), param('uint64_t', 'val')])
add_checked_function(mod, 'datago_GetClient', retval('int64_t'), [param('char*', 'sources'), param('bool', 'require_images'), param('bool', 'require_embeddings'), param('char*', 'tags'), param('char*', 'tags__ne'), param('char*', 'has_attributes'), param('char*', 'lacks_attributes'), param('char*', 'has_masks'), param('char*', 'lacks_masks'), param('char*', 'has_latents'), param('char*', 'lacks_latents'), param('bool', 'crop_and_resize'), param('int64_t', 'default_image_size'), param('int64_t', 'downsampling_ratio'), param('bool', 'pre_encode_images'), param('uint32_t', 'rank'), param('uint32_t', 'world_size'), param('int64_t', 'prefetch_buffer_size'), param('int64_t', 'samples_buffer_size'), param('int64_t', 'downloads_concurrency')])

mod.generate(open('datago.c', 'w'))

